import { createSlice } from '@reduxjs/toolkit';

export interface MapState {
  viewport: {
    width: number;
    height: number;
  };
}

const initialMapState: MapState = {
  viewport: {
    width: window.innerWidth,
    height: window.innerHeight,
  },
};

const mapSlice = createSlice({
  name: 'map',
  initialState: initialMapState,
  reducers: {
    resize: (state) => {
        state.viewport.height = window.innerHeight;
        state.viewport.width = window.innerWidth;
    },
  },
});

export const mapActions = mapSlice.actions;

export default mapSlice.reducer;
